#ifndef __PerformingOperation_h_INCLUDED_H__
#define __PerformingOperation_h_INCLUDED_H__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream>
#include <vector>


/** file PerformingOperation.h */


//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------
class PerformingOperation {

	public:

	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

	PerformingOperation();

	~PerformingOperation();

	
	//------------------------------------------------------------------------------------------------------------
	//  Attributes getters and setters
	//------------------------------------------------------------------------------------------------------------
	
	void setStartOperationInstantVector( std::vector<int> instantData );

	std::vector<int> getStartOperationInstantVector( );

	void setEndOperationInstantVector( std::vector<int> instantData );

	std::vector<int> getEndOperationInstantVector( );

	char getStartCommand();

	void setStartCommand( char theCommand );

	char getEndCommand();

	void setEndCommand( char theCommand );

	std::vector<std::string> getKeyNamesOperationElems( );

	void setKeyNamesOperationElems( std::vector<std::string> dataVector);

	//------------------------------------------------------------------------------------------------------------
	//  Other functional methods
	//------------------------------------------------------------------------------------------------------------

	void reset();

private:
	//------------------------------------------------------------------------------------------------------------
	//  Private methods
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	// Creational and initialization methods
	//------------------------------------------------------------------------------------------------------------

		
	//------------------------------------------------------------------------------------------------------------
	// Attributtes
	//------------------------------------------------------------------------------------------------------------
	
	std::vector<int>  _startOperationInstantVector;

	std::vector<int>  _endOperationInstantVector;

	std::vector<std::string> _keyNamesOperationElems;

	char _startCommand;

	char _endCommand;

};
#endif // __PerformingOperation_HEADER_FILE__



