#include "bbCreaContournDimensions.h"
#include "bbcreaContoursPackage.h"
namespace bbcreaContours
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaContours,nDimensions)
BBTK_BLACK_BOX_IMPLEMENTATION(nDimensions,bbtk::WxBlackBox);
void nDimensions::Process()
{

	double **vectx, **vecty, **vectz;

	std::vector< void * > vectortemp;
	std::vector<int> size;
	vtkImageData **mask, **value;

	vtkImageData* img = bbGetInputIn();

	std::vector<vtkImageData*> selectedimages;
	if(img!=NULL && currentimg!=img){

		wxContourMainFrame::getInstance()->ShowToolsPanel(true);
		currentimg=img;
		selectedimages.push_back(img);
		wxContourMainFrame::getInstance()->setVectImages(selectedimages);
	}



	if(currentimg != NULL){
		int contourtype = bbGetInputContourType();
		//wxContourMainFrame::getInstance()->getValuesXYZ(vectx, vecty, vectz, &size);
		//wxContourMainFrame::getInstance()->getMaskValue(mask, value, contourtype);
	}

    bbSetOutputX(vectx);
	bbSetOutputY(vecty);
	bbSetOutputZ(vectz);
	bbSetOutputSizeContour(size);
	bbSetOutputMask(*mask);
	bbSetOutputValue(*value);
}
void nDimensions::CreateWidget(wxWindow* parent)
{

	//vtkImageData* img = bbGetInputIn();

	std::vector<vtkImageData*> selectedimages;
	//selectedimages.push_back(img);

	//wxFrame* frame1 = new wxFrame(parent, wxID_ANY, wxT("ROI Application  -    Evaluation version, 23 Oct 2008 "), wxPoint(400,50), wxSize(800, 600) );
	//frame = wxContourMainFrame::getInstance(frame1, wxID_ANY, wxString(_T("")), wxPoint(100,50), wxSize(800, 600), selectedimages );
	//new wxContourMainFrame( frame1, wxID_ANY, _T(""), wxPoint(50,50), wxSize(800, 600),selectedimages );
	//frame1->CreateStatusBar();
	//bbSetOutputWidget( frame1 );
std::string path=".";
#ifdef WIN32
	char currentPath[_MAX_PATH];
	HMODULE hand = GetModuleHandle("bbcreaContours");
	GetModuleFileName(hand, currentPath, _MAX_PATH);

	path = currentPath;

	path = path.substr(0,path.find_last_of("\\"));
#endif

	wxPanel* panel = wxContourMainFrame::getInstance(parent, wxID_ANY, wxString(_T("")), wxPoint(100,50), wxSize(800, 600), selectedimages,wxDEFAULT_FRAME_STYLE | wxSUNKEN_BORDER,path );
	wxContourMainFrame::getInstance()->ShowToolsPanel(false);
	//std::cout<<"creaContours = "<<panel<<std::endl;
	bbSetOutputWidget( panel );





}
//-----------------------------------------------------------------
void nDimensions::bbUserSetDefaultValues()
{
	bbSetInputContourType(0);
	bbSetInputIn(NULL);
}

//-----------------------------------------------------------------
void nDimensions::bbUserInitializeProcessing()
{
}

//-----------------------------------------------------------------
void nDimensions::bbUserFinalizeProcessing()
{
}
}
// EO namespace bbCreaContour


